var scfRunner = {
  scfDBconnection: null,
  scfDBfile: null,
  scfDBfieldnames: null,
  scfCardMod: null,
  scfCardSort: null,

  onLoad: function() {
    var scfMyWindow = document.getElementById("scfRunnerWindow");
    if (scfMyWindow !== null) {
      scfMyWindow.setAttribute("maxwidth",window.screen.availWidth);
      scfMyWindow.setAttribute("maxheight",window.screen.availHeight);
      scfMyWindow.focus();
    }
    this.scfDBconnection = null;
    this.scfDBfile = null;
    this.scfDBfieldnames = null;
    this.scfCardMod = false;
  },

  scfChildNodeCleanup: function(localParentNode) {
    while (localParentNode.firstChild) {
      if (localParentNode.firstChild.hasChildNodes()) {
        this.scfChildNodeCleanup(localParentNode.firstChild);
      }
      localParentNode.removeChild(localParentNode.firstChild);
    }
  },

  scfCardSave: function() {
    var localCardCount = parseInt(document.getElementById("scfRunnerCardContainer")
                                              .getAttribute("scfcardcount"));
    if (isFinite(localCardCount) == false) { localCardCount = 0; }
    if (localCardCount < 0) { localCardCount = 0; }
    var localCardId = parseInt(document.getElementById("scfRunnerCardContainer")
                                              .getAttribute("scfcardid"));
    if (isFinite(localCardId) == false) { localCardId = 0; }
    if (localCardId < 0) { localCardId = 0; }
    if ((this.scfDBconnection != null) && (localCardCount > 0) && (localCardId >= 0)) {
      try {
        var localSQLquery = null;
        var localParamCount = this.scfDBfieldnames.length;
        var localParamValue = "";
        var localParamType = "";
        for (var i = 0; i < localParamCount; i++) {
          localParamValue = document.getElementById("scfGrid"+this.scfDBfieldnames[i][0]+"value").getAttribute("label");
          localParamType = document.getElementById("scfGrid"+this.scfDBfieldnames[i][0]+"treeitem").getAttribute("scfFieldType");
          localParamType = localParamType.toUpperCase();
          switch (localParamType) {
            case "INTEGER": localParamValue = parseInt(localParamValue);
              if (isFinite(localParamValue) == false) { localParamValue = 0; }
              break;
            case "REAL": localParamValue = parseFloat(localParamValue);
              if (isFinite(localParamValue) == false) { localParamValue = 0.0; }
              break;
            default: localParamValue = String(localParamValue);
          }
          localSQLquery = this.scfDBconnection.createStatement("UPDATE data SET "+String(this.scfDBfieldnames[i][0])+" = :fieldvalue WHERE id = :cardid");
          localSQLquery.params.fieldvalue = localParamValue;
          localSQLquery.params.cardid = localCardId;
          localSQLquery.executeStep();
          localSQLquery.reset();
          localSQLquery.finalize();
        }
      } catch (e) {
        localSQLquery.reset();
        localSQLquery.finalize();
      }
    }
    this.scfCardMod = false;
  },

  scfCardLoad: function(cardoffset) {
    if (this.scfCardMod == true) { this.scfCardSave(); }
    var localCardCount = parseInt(document.getElementById("scfRunnerCardContainer")
                                              .getAttribute("scfcardcount"));
    if (isFinite(localCardCount) == false) { localCardCount = 0; }
    if (localCardCount < 0) { localCardCount = 0; }
    var localCardOffset = parseInt(cardoffset);
    if (isFinite(localCardOffset) == false) { localCardOffset = 0; }
    if (localCardOffset < 0) { localCardOffset = 0; }
    if (localCardOffset >= localCardCount) { localCardOffset = localCardCount - 1; }
    if ((this.scfDBconnection != null) && (localCardCount > 0) && (localCardOffset >= 0)) {
      try {
        var localCardSort = String(document.getElementById("scfRunnerCardContainer").getAttribute("scfcardsort"));
        var localSQLquery = null;
        if (localCardSort != "blank") {
          localSQLquery = this.scfDBconnection.createStatement("SELECT id FROM data ORDER BY "+localCardSort+" LIMIT 1 OFFSET :cardoffset");
        } else {
          localSQLquery = this.scfDBconnection.createStatement("SELECT id FROM data ORDER BY id LIMIT 1 OFFSET :cardoffset");
        }
        localSQLquery.params.cardoffset = localCardOffset;
        localSQLquery.executeStep();
        var localSQLid = localSQLquery.row.id;
        document.getElementById("scfRunnerCardContainer").setAttribute("scfcardid",String(localSQLid));
        document.getElementById("scfRunnerCardContainer").setAttribute("scfcardoffset",String(localCardOffset));
        localSQLquery.reset();
        localSQLquery.finalize();
        var localParamCount = this.scfDBfieldnames.length;
        var localParamValue = "";
        for (var i = 0; i < localParamCount; i++) {
          localSQLquery = this.scfDBconnection.createStatement("SELECT "+String(this.scfDBfieldnames[i][0])+" AS name FROM data WHERE id = :cardid");
          localSQLquery.params.cardid = localSQLid;
          localSQLquery.executeStep();
          localParamValue = localSQLquery.row.name;
          document.getElementById("scfGrid"+this.scfDBfieldnames[i][0]+"value").setAttribute("label",String(localParamValue));
          localSQLquery.reset();
          localSQLquery.finalize();
        }
        document.getElementById("scfRunnerCardContainer").setAttribute("scfcardid",String(localSQLid));
        if (localCardOffset > 0) {
          document.getElementById("scfCardFirstPrev").setAttribute("disabled","false");
        } else {
          document.getElementById("scfCardFirstPrev").setAttribute("disabled","true");
        }
        if (localCardOffset < (localCardCount-1)) {
          document.getElementById("scfCardLastNext").setAttribute("disabled","false");
        } else {
          document.getElementById("scfCardLastNext").setAttribute("disabled","true");
        }
        localParamCount = document.getElementById("scfStrings").getString("scfRunnerStatusLabelText1");
        localParamValue = document.getElementById("scfStrings").getString("scfRunnerStatusLabelText2");
        document.getElementById("scfRunnerStatusLabel").
            setAttribute("value",localParamCount+" "+String((localCardOffset+1))+" "+localParamValue+" "+String(localCardCount));
      } catch (e) {
        localSQLquery.reset();
        localSQLquery.finalize();
      }
    }
  },

  scfDBclose: function() {
    if (this.scfDBconnection != null) {
      if (this.scfCardMod == true) { this.scfCardSave(); }
      try {
        this.scfDBconnection.close();
      } catch (e) {
        this.scfDBconnection = null;
      }
      this.scfDBconnection = null;
    }
    this.scfDBfile = null;
    this.scfDBfieldnames = null;
    this.scfCardMod = false;
    document.getElementById("scfRunnerCardLabel").setAttribute("label",
      document.getElementById("scfStrings").getString("scfBlankFileTitle"));
    this.scfChildNodeCleanup(document.getElementById("scfNewFieldTreeChildren"));
    document.getElementById("scfNewFieldTreeFieldName").setAttribute("label",
      document.getElementById("scfStrings").getString("scfTreeColumn1"));
    document.getElementById("scfNewFieldTreeFieldType").setAttribute("label",
      document.getElementById("scfStrings").getString("scfTreeColumn2"));
    document.getElementById("scfFileOpened").setAttribute("disabled","false");
    document.getElementById("scfCardWritable").setAttribute("disabled","true");
    document.getElementById("scfCardFirstPrev").setAttribute("disabled","true");
    document.getElementById("scfCardLastNext").setAttribute("disabled","true");
    document.getElementById("scfCardTools").setAttribute("hidden","true");
    document.getElementById("scfFieldControls").setAttribute("hidden","true");
    document.getElementById("scfFieldTools").setAttribute("disabled","true");
    document.getElementById("scfRunnerCardContainer").setAttribute("scfcardcount","0");
    document.getElementById("scfRunnerCardContainer").setAttribute("scfcardoffset","0");
    document.getElementById("scfRunnerCardContainer").setAttribute("scfcardid","-1");
    document.getElementById("scfRunnerCardContainer").setAttribute("scfcardsort","blank");
    document.getElementById("scfRunnerStatusLabel").setAttribute("value","");
  },

  scfCardUpdated: function() {
    var localStatusCheck = document.getElementById("scfCardTools").getAttribute("hidden");
    localStatusCheck = localStatusCheck.toLowerCase();
    if (localStatusCheck == "false") { this.scfCardMod = true; }
  },

  scfDBload: function() {
    var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                           .getService(Components.interfaces.nsIPromptService);
    var localPromptTitle = document.getElementById("scfStrings")
                                .getString("scfLoadDatabaseAlertTitle");
    var localPromptMessage = "";
    if (this.scfDBconnection != null) {
      if (this.scfDBconnection.tableExists("layout") &&
          this.scfDBconnection.tableExists("fields") &&
          this.scfDBconnection.tableExists("data")) {
        try {
          var localFieldNames = new Array();
          var localCounter = 0;
          var localSQLid = 0;
          var localSQLname = "";
          var scfFieldParent = document.getElementById("scfNewFieldTreeChildren");
          var localNewTreeItem = null;
          var localNewTreeRow = null;
          var localNewTreeCell1 = null;
          var localNewTreeCell2 = null;
          var localCardSort = String(document.getElementById("scfRunnerCardContainer").getAttribute("scfcardsort"));
          var localSQLquery = null;
          if (localCardSort != "blank") {
            localSQLquery = this.scfDBconnection.createStatement("SELECT * FROM fields ORDER BY "+localCardSort);
          } else {
            localSQLquery = this.scfDBconnection.createStatement("SELECT * FROM fields ORDER BY id");
          }
          while (localSQLquery.step()) {
            localSQLid = localSQLquery.row.id;
            localSQLname = localSQLquery.row.name;
            localCounter = localFieldNames.push([localSQLquery.row.name,localSQLquery.row.fieldname]);
            localNewTreeItem = document.createElement("treeitem");
              localNewTreeItem.setAttribute("id","scfGrid"+localSQLname+"treeitem");
              localNewTreeItem.setAttribute("scfFieldType",localSQLquery.row.fieldtype);
            localNewTreeRow = document.createElement("treerow");
              localNewTreeRow.setAttribute("id","scfGrid"+localSQLname+"treerow");
            localNewTreeCell1 = document.createElement("treecell");
              localNewTreeCell1.setAttribute("id","scfGrid"+localSQLname+"label");
              localNewTreeCell1.setAttribute("label",localSQLquery.row.fieldname);
              localNewTreeCell1.setAttribute("editable","false");
            localNewTreeCell2 = document.createElement("treecell");
              localNewTreeCell2.setAttribute("id","scfGrid"+localSQLname+"value");
              localNewTreeCell2.setAttribute("label","");
              localNewTreeCell2.setAttribute("editable","true");
            localNewTreeRow.appendChild(localNewTreeCell1);
            localNewTreeRow.appendChild(localNewTreeCell2);
            localNewTreeItem.appendChild(localNewTreeRow);
            scfFieldParent.appendChild(localNewTreeItem);
          }
          localSQLquery.finalize();
          this.scfDBfieldnames = localFieldNames;
          localSQLquery = this.scfDBconnection.createStatement("SELECT COUNT(*) AS cardcount FROM data");
          localSQLquery.executeStep();
          document.getElementById("scfRunnerCardContainer")
                     .setAttribute("scfcardcount",String(localSQLquery.row.cardcount));
          document.getElementById("scfRunnerCardContainer").setAttribute("scfcardoffset","0");
          localSQLquery.reset();
          localSQLquery.finalize();
          localCounter = document.getElementById("scfRunnerCardContainer").getAttribute("scfcardcount");
          localNewRowItem1 = document.getElementById("scfStrings").getString("scfRunnerStatusLabelText1");
          localNewRowItem2 = document.getElementById("scfStrings").getString("scfRunnerStatusLabelText2");
          document.getElementById("scfRunnerStatusLabel").
              setAttribute("value",localNewRowItem1+" 0 "+localNewRowItem2+" "+localCounter);
          document.getElementById("scfCardTools").setAttribute("hidden","false");
          document.getElementById("scfNewFieldTreeFieldName").setAttribute("label",
            document.getElementById("scfStrings").getString("scfTreeColumn1a"));
          document.getElementById("scfNewFieldTreeFieldName").setAttribute("flex","1");
          document.getElementById("scfNewFieldTreeFieldName").setAttribute("editable","false");
          document.getElementById("scfNewFieldTreeFieldType").setAttribute("label",
            document.getElementById("scfStrings").getString("scfTreeColumn2a"));
          document.getElementById("scfNewFieldTreeFieldType").setAttribute("flex","2");
          document.getElementById("scfNewFieldTreeFieldType").setAttribute("editable","true");
          this.scfCardLoad(0);
        } catch (e) {
          localSQLquery.reset();
          localSQLquery.finalize();
          localPromptMessage = document.getElementById("scfStrings")
                                    .getString("scfLoadDatabaseBadMessage");
          localPrompts.alert(null,localPromptTitle, localPromptMessage);
          this.scfDBclose();
        }
      } else {
        localPromptMessage = document.getElementById("scfStrings")
                                  .getString("scfLoadDatabaseInvalidMessage");
        localPrompts.alert(null,localPromptTitle, localPromptMessage);
        this.scfDBclose();
      }
    } else {
      localPromptMessage = document.getElementById("scfStrings")
                                .getString("scfLoadDatabaseFailMessage");
      localPrompts.alert(null,localPromptTitle, localPromptMessage);
    }
  },

  scfCreateNewField: function() {
    var localNodeParent = document.getElementById("scfNewFieldTreeChildren");
    var localItemCount = parseInt(localNodeParent.getAttribute("scfitemcount"));
    if (isFinite(localItemCount) == false) { localItemCount = 0; }
    localItemCount++;
    var localItemCountTxt = "scfitemcount"+String(localItemCount);
    var localTreeItem = document.createElement("treeitem");
      localTreeItem.setAttribute("id",localItemCountTxt+"treeItem");
      localTreeItem.setAttribute("scfindex",localItemCountTxt);
    var localTreeRow = document.createElement("treerow");
      localTreeRow.setAttribute("id",localItemCountTxt+"treeRow");
    var localTreeCell1 = document.createElement("treecell");
      localTreeCell1.setAttribute("id",localItemCountTxt+"FieldName");
      localTreeCell1.setAttribute("label",
        document.getElementById("scfFieldToolsFieldName").value);
      localTreeCell1.setAttribute("editable","true");
    var localTreeCell2 = document.createElement("treecell");
      localTreeCell2.setAttribute("id",localItemCountTxt+"FieldType");
      localTreeCell2.setAttribute("label",
        document.getElementById("scfFieldToolsFieldMenulist").selectedItem.value);
      localTreeCell2.setAttribute("editable","false");
    localTreeRow.appendChild(localTreeCell1);
    localTreeRow.appendChild(localTreeCell2);
    localTreeItem.appendChild(localTreeRow);
    localNodeParent.appendChild(localTreeItem);
    localNodeParent.setAttribute("scfitemcount",String(localItemCount));
  },

  scfDeleteNewField: function() {
    var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                           .getService(Components.interfaces.nsIPromptService);
    var localPromptTitle = document.getElementById("scfStrings")
                                .getString("scfDeleteFieldAlertTitle");
    var localNodeParentTree = document.getElementById("scfNewFieldTree");
    var localNodeParentTreeChildren = document.getElementById("scfNewFieldTreeChildren");
    var localSelectedChildIdx = localNodeParentTree.currentIndex;
    var localTreeChildrenNodes = localNodeParentTreeChildren.childNodes;
    if ((localSelectedChildIdx >= 0) && (localSelectedChildIdx < localTreeChildrenNodes.length)) {
      var localPromptMessage = document.getElementById("scfStrings")
                                 .getString("scfDeleteFieldAlertConfirm");
      if (localPrompts.confirm(null,localPromptTitle, localPromptMessage)) {
        var tempNode = localTreeChildrenNodes[localSelectedChildIdx];
        this.scfChildNodeCleanup(tempNode);
        localNodeParentTreeChildren.removeChild(tempNode);
      }
    } else {
      var localPromptMessage = document.getElementById("scfStrings")
                                 .getString("scfDeleteFieldAlertMessage");
      localPrompts.alert(null,localPromptTitle, localPromptMessage);
    }
  },

  scfFinishedNewField: function() {
    var localDBservice = Components.classes["@mozilla.org/storage/service;1"]
                           .getService(Components.interfaces.mozIStorageService);
    var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                           .getService(Components.interfaces.nsIPromptService);
    var localPromptTitle = document.getElementById("scfStrings")
                                .getString("scfCreateDatabaseAlertTitle");
    var localNodeParentTreeChildren = document.getElementById("scfNewFieldTreeChildren");
    var localTreeItemNodes = localNodeParentTreeChildren.childNodes;
    if (localTreeItemNodes.length > 0) {
      var localFileCreated = false;
      try {
        if (this.scfDBfile.exists() == true) { this.scfDBfile.remove(false); }
        var localDBconn = localDBservice.openDatabase(this.scfDBfile);
        this.scfDBconnection = localDBconn;
        localFileCreated = true;
      } catch (e) {
        localFileCreated = false;
      }
      if (localFileCreated == true) {
        try {
          this.scfDBconnection.createTable("layout",
            "id INTEGER UNIQUE PRIMARY KEY AUTOINCREMENT NOT NULL, name TEXT COLLATE NOCASE, fieldlist TEXT");
          this.scfDBconnection.createTable("fields",
            "id INTEGER UNIQUE PRIMARY KEY AUTOINCREMENT NOT NULL, name TEXT COLLATE NOCASE, fieldname TEXT, fieldtype TEXT");
          var localCounter = 0;
          var localCounterText = "";
          var localRowNode = null;
          var localFieldName = "";
          var localFieldType = "";
          var localDataTable = "id INTEGER UNIQUE PRIMARY KEY AUTOINCREMENT NOT NULL";
          var localSQLquery = this.scfDBconnection.createStatement("INSERT INTO fields (name,fieldname,fieldtype) VALUES (:name,:fieldname,:fieldtype)");
          for (localCounter = 0; localCounter < localTreeItemNodes.length; localCounter++) {
            localCounterText = "field"+String(localCounter);
            localRowNode = localTreeItemNodes[localCounter].firstChild;
            localFieldName = localRowNode.firstChild.getAttribute("label");
            localFieldType = localRowNode.lastChild.getAttribute("label");
            localSQLquery.params.name = localCounterText;
            localSQLquery.params.fieldname = localFieldName;
            localSQLquery.params.fieldtype = localFieldType;
            localSQLquery.executeStep();
            localSQLquery.reset();
            localFieldName = localFieldType.toUpperCase();
            switch (localFieldName) {
              case "TEXT": localFieldType = localFieldType + " DEFAULT \"\"";
                break;
              case "INTEGER": localFieldType = localFieldType + " DEFAULT 0";
                break;
              case "REAL": localFieldType = localFieldType + " DEFAULT 0.0";
                break;
            }
            localDataTable = localDataTable+", "+localCounterText+" "+localFieldType;
            localFieldName = "";
            localFieldType = "";
          }
          this.scfDBconnection.createTable("data",localDataTable);
          localSQLquery.finalize();
          document.getElementById("scfCardWritable").setAttribute("disabled","false");
          this.scfChildNodeCleanup(document.getElementById("scfNewFieldTreeChildren"));
          document.getElementById("scfFieldControls").setAttribute("hidden","true");
          document.getElementById("scfFieldTools").setAttribute("disabled","true");
          this.scfDBload();
        } catch (e) {
          localSQLquery.reset();
          localSQLquery.finalize();
          var localPromptMessage = document.getElementById("scfStrings")
                                     .getString("scfCreateDatabaseTableError");
          localPrompts.alert(null,localPromptTitle, localPromptMessage);
          this.scfDBclose();
        }
      } else {
        var localPromptMessage = document.getElementById("scfStrings")
                                   .getString("scfCreateDatabaseCreateError");
        localPrompts.alert(null,localPromptTitle, localPromptMessage);
        this.scfDBclose();
      }
    } else {
      var localPromptMessage = document.getElementById("scfStrings")
                                 .getString("scfCreateDatabaseAlertError");
      localPrompts.alert(null,localPromptTitle, localPromptMessage);
      this.scfDBclose();
    }
  },

  scfDBaccess: function(localAction) {
    if (localAction == undefined) {
      localAction = "open";
    } else {
      localAction = localAction.toLowerCase();
    }
    var scfPickerInterface = Components.interfaces.nsIFilePicker;
    var scfFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(scfPickerInterface);
    var localTempText = "";
    if (localAction == "new") {
      localTempText = document.getElementById("scfStrings").getString("scfDBaccessNewDB");
      scfFilePicker.init(window, localTempText, scfPickerInterface.modeSave);
    } else {
      localTempText = document.getElementById("scfStrings").getString("scfDBaccessOpenDB");
      scfFilePicker.init(window, localTempText, scfPickerInterface.modeOpen);
    }
    localTempText = document.getElementById("scfStrings").getString("scfDBaccessPickerFilter");
    scfFilePicker.appendFilter (localTempText,"*.sqlcard; *.sqlcardfile");
    scfFilePicker.appendFilters(scfPickerInterface.filterAll);
    if (scfFilePicker.show() != scfPickerInterface.returnCancel) {
      this.scfDBclose();
      document.getElementById("scfFileOpened").setAttribute("disabled","true");
      this.scfDBfile = scfFilePicker.file;
      if (localAction == "new") {
        document.getElementById("scfRunnerCardLabel").setAttribute("label",
          this.scfDBfile.leafName);
        document.getElementById("scfFieldControls").setAttribute("hidden","false");
        document.getElementById("scfFieldTools").setAttribute("disabled","false");
        document.getElementById("scfNewFieldTreeFieldName").setAttribute("flex","2");
        document.getElementById("scfNewFieldTreeFieldName").setAttribute("editable","true");
        document.getElementById("scfNewFieldTreeFieldType").setAttribute("flex","1");
        document.getElementById("scfNewFieldTreeFieldType").setAttribute("editable","false");
      } else {
        if ((this.scfDBfile.exists() == true) && (this.scfDBfile.isReadable() == true)){
          if (this.scfDBfile.isWritable() == true) {
            document.getElementById("scfRunnerCardLabel").setAttribute("label",
              this.scfDBfile.leafName);
            document.getElementById("scfCardWritable").setAttribute("disabled","false");
          } else {
            document.getElementById("scfRunnerCardLabel").setAttribute("label",
              this.scfDBfile.leafName+" (Read-Only)");
            document.getElementById("scfCardWritable").setAttribute("disabled","true");
          }
          var localDBservice = Components.classes["@mozilla.org/storage/service;1"]
                                   .getService(Components.interfaces.mozIStorageService);
          try {
            var localDBconn = localDBservice.openDatabase(this.scfDBfile);
            this.scfDBconnection = localDBconn;
            this.scfDBload();
          } catch (e) {
            this.scfDBclose();
          }
        } else {
          var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                 .getService(Components.interfaces.nsIPromptService);
          var localPromptTitle = document.getElementById("scfStrings")
                                     .getString("scfOpenDatabaseErrorTitle");
          var localPromptMessage = document.getElementById("scfStrings")
                                     .getString("scfOpenDatabaseErrorMessage");
          localPrompts.alert(null,localPromptTitle, localPromptMessage);
        }
      }
    }
  },

  scfCardAccess: function(localAction) {
    if (this.scfCardMod == true) { this.scfCardSave(); }
    switch (localAction) {
      case "new":
        var localDialogParams = {inn:null, out:null};
        localDialogParams.inn = this.scfDBfieldnames;
        var localRetVal = window.openDialog("chrome://sqlcardfile/content/scfaOverlay.xul", "",
                            "chrome, dialog, modal, resizable=yes", localDialogParams).focus();
        try {
          this.scfDBconnection.executeSimpleSQL("INSERT INTO data DEFAULT VALUES");
          var localCardCount = 0;
          var localSQLquery = this.scfDBconnection.createStatement("SELECT COUNT(*) AS cardcount FROM data");
          localSQLquery.executeStep();
          localCardCount = parseInt(localSQLquery.row.cardcount);
          localSQLquery.reset();
          localSQLquery.finalize();
          document.getElementById("scfRunnerCardContainer").setAttribute("scfcardcount",String(localCardCount));
          localCardCount = localCardCount - 1;
          this.scfCardLoad(localCardCount);
          var localNewArray = localDialogParams.out;
          if ((Array.isArray(localNewArray)) && (localNewArray.length = this.scfDBfieldnames.length)) {
            var localRowID = "";
            for (localCounter = 0; localCounter < localNewArray.length; localCounter++) {
              localRowID = this.scfDBfieldnames[localCounter][0];
              document.getElementById("scfGrid"+localRowID+"value").setAttribute("label",localNewArray[localCounter]);
            }
            this.scfCardSave();
          }
        } catch (e) {
          localSQLquery.reset();
          localSQLquery.finalize();
        }
        break;
      case "delete":
        var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                               .getService(Components.interfaces.nsIPromptService);
        var localPromptTitle = document.getElementById("scfStrings")
                                   .getString("scfCardAccessDeleteTitle");
        var localPromptMessage = document.getElementById("scfStrings")
                                   .getString("scfCardAccessDeleteMessage");
        if (localPrompts.confirm(null,localPromptTitle, localPromptMessage) == true) {
          var localCardID = parseInt(document.getElementById("scfRunnerCardContainer")
                                                    .getAttribute("scfcardid"));
          if (isFinite(localCardID) == false) { localCardID = -1; }
          if (localCardID >= 0) {
            var localCardCount = 0;
            try {
              this.scfDBconnection.executeSimpleSQL("DELETE FROM data WHERE id="+String(localCardID));
              var localSQLquery = this.scfDBconnection.createStatement("SELECT COUNT(*) AS cardcount FROM data");
              localSQLquery.executeStep();
              localCardCount = parseInt(localSQLquery.row.cardcount);
              localSQLquery.reset();
              localSQLquery.finalize();
            } catch (e) {
              localSQLquery.reset();
              localSQLquery.finalize();
            }
            if (isFinite(localCardCount) == false) { localCardCount = 0; }
            document.getElementById("scfRunnerCardContainer").setAttribute("scfcardcount",String(localCardCount));
            var localCardOffset = parseInt(document.getElementById("scfRunnerCardContainer")
                                               .getAttribute("scfcardoffset"));
            if (isFinite(localCardOffset) == false) { localCardOffset = 0; }
            if (localCardOffset < 0) { localCardOffset = 0; }
            if (localCardOffset >= localCardCount) { localCardOffset = localCardCount - 1; }
            this.scfCardLoad(localCardOffset);
          }
        }
        break;
      case "copy":
        var localNewArray = new Array();
        var localCounter = 0;
        var localRowID = "";
        for (localCounter = 0; localCounter < this.scfDBfieldnames.length; localCounter++) {
          localRowID = this.scfDBfieldnames[localCounter][0];
          localNewArray[localCounter] = document.getElementById("scfGrid"+localRowID+"value").getAttribute("label");
        }
        try {
          this.scfDBconnection.executeSimpleSQL("INSERT INTO data DEFAULT VALUES");
          var localCardCount = 0;
          var localSQLquery = this.scfDBconnection.createStatement("SELECT COUNT(*) AS cardcount FROM data");
          localSQLquery.executeStep();
          localCardCount = parseInt(localSQLquery.row.cardcount);
          localSQLquery.reset();
          localSQLquery.finalize();
          document.getElementById("scfRunnerCardContainer").setAttribute("scfcardcount",String(localCardCount));
          localCardCount = localCardCount - 1;
          this.scfCardLoad(localCardCount);
          for (localCounter = 0; localCounter < this.scfDBfieldnames.length; localCounter++) {
            localRowID = this.scfDBfieldnames[localCounter][0];
            document.getElementById("scfGrid"+localRowID+"value").setAttribute("label",localNewArray[localCounter]);
          }
          this.scfCardSave();
        } catch (e) {
          localSQLquery.reset();
          localSQLquery.finalize();
        }
        break;
    }
  },

  scfCardNav: function(localAction) {
    var localCardCount = parseInt(document.getElementById("scfRunnerCardContainer")
                                              .getAttribute("scfcardcount"));
    if (isFinite(localCardCount) == false) { localCardCount = 0; }
    if (localCardCount < 0) { localCardCount = 0; }
    var localCardOffset = parseInt(document.getElementById("scfRunnerCardContainer")
                                               .getAttribute("scfcardoffset"));
    if (isFinite(localCardOffset) == false) { localCardOffset = 0; }
    if (localCardOffset < 0) { localCardOffset = 0; }
    if (localCardOffset >= localCardCount) { localCardOffset = localCardCount - 1; }
    switch (localAction) {
      case "pick":
                var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                     .getService(Components.interfaces.nsIPromptService);
                var localPromptTitle = document.getElementById("scfStrings")
                                         .getString("scfCardNavPickTitle");
                if (localCardCount > 1) {
                  var localPromptMessage = document.getElementById("scfStrings")
                                             .getString("scfCardNavPickMessage1");
                  localPromptMessage = localPromptMessage + " " + String(localCardCount) + ":";
                  var localCheck = {value : false};
                  var localInput = {value : "1"};
                  var localResult = localPrompts.prompt(null,localPromptTitle, localPromptMessage, localInput, null, localCheck);
                  if (localResult == true) {
                    localCardOffset = parseInt(localInput.value);
                    if (isFinite(localCardOffset) == false) { localCardOffset = 0; }
                    localCardOffset = localCardOffset - 1;
                    if (localCardOffset < 0) { localCardOffset = 0; }
                    if (localCardOffset >= localCardCount) { localCardOffset = localCardCount - 1; }
                    this.scfCardLoad(localCardOffset);
                  }
                } else {
                  var localPromptMessage = document.getElementById("scfStrings")
                                             .getString("scfCardNavPickMessage2");
                  localPrompts.alert(null,localPromptTitle, localPromptMessage);
                }
                break;
      case "last": this.scfCardLoad((localCardCount-1));
                break;
      case "next": localCardOffset = localCardOffset + 1;
                    if (localCardOffset >= localCardCount) { localCardOffset = localCardCount - 1; }
                    this.scfCardLoad(localCardOffset);
                break;
      case "prev": localCardOffset = localCardOffset - 1;
                    if (localCardOffset < 0) { localCardOffset = 0; }
                    this.scfCardLoad(localCardOffset);
                break;
      default: this.scfCardLoad(0);
    }
  },

  scfDataExport: function() {
    if (this.scfCardMod == true) { this.scfCardSave(); }
    var localPickerInterface = Components.interfaces.nsIFilePicker;
    var localFilePicker = Components.classes["@mozilla.org/filepicker;1"].createInstance(localPickerInterface);
    var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                           .getService(Components.interfaces.nsIPromptService);
    var localPromptTitle = document.getElementById("scfStrings").getString("scfDataExportTitle");
    var localTempText = document.getElementById("scfStrings").getString("scfDataExportPickerTitle");
    localFilePicker.init(window, localTempText, localPickerInterface.modeSave);
    localTempText = document.getElementById("scfStrings").getString("scfDataExportPickerFilter");
    localFilePicker.appendFilter (localTempText,"*.txt; *.tab; *.tsv");
    localFilePicker.appendFilters(localPickerInterface.filterAll | localPickerInterface.filterText);
    if (localFilePicker.show() != localPickerInterface.returnCancel) {
      var localDataExportFile = localFilePicker.file;
      var localFileStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                                    .createInstance(Components.interfaces.nsIFileOutputStream);
      localFileStream.init(localDataExportFile, 0x02 | 0x08 | 0x20, 0666, 0);
      var localFileConverter = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
                                    .createInstance(Components.interfaces.nsIConverterOutputStream);
      localFileConverter.init(localFileStream, "UTF-8", 0, "?".charCodeAt(0));
      var localFieldCounter = this.scfDBfieldnames.length;
      localFieldCounter = localFieldCounter - 1;
      var localCounter = 0;
      for (localCounter = 0; localCounter <= localFieldCounter; localCounter++) {
        localFileConverter.writeString(String(this.scfDBfieldnames[localCounter][1]));
        if (localCounter == localFieldCounter) {
          localFileConverter.writeString("\n");
        } else {
          localFileConverter.writeString("\t");
        }
      }
      var localCardCount = parseInt(document.getElementById("scfRunnerCardContainer")
                                                .getAttribute("scfcardcount"));
      if (isFinite(localCardCount) == false) { localCardCount = 0; }
      localCardCount = localCardCount - 1;
      if (localCardCount < 0) { localCardCount = 0; }
      try {
        var localCardSort = String(document.getElementById("scfRunnerCardContainer").getAttribute("scfcardsort"));
        var localSQLquery = null;
        var localSQLid = null;
        var localCounter2 = 0;
        for (localCounter = 0; localCounter <= localCardCount; localCounter++) {
          if (localCardSort != "blank") {
            localSQLquery = this.scfDBconnection.createStatement("SELECT id FROM data ORDER BY "+localCardSort+" LIMIT 1 OFFSET :cardoffset");
          } else {
            localSQLquery = this.scfDBconnection.createStatement("SELECT id FROM data ORDER BY id LIMIT 1 OFFSET :cardoffset");
          }
          localSQLquery.params.cardoffset = localCounter;
          localSQLquery.executeStep();
          localSQLid = localSQLquery.row.id;
          localSQLquery.reset();
          localSQLquery.finalize();
          for (localCounter2 = 0; localCounter2 <= localFieldCounter; localCounter2++) {
            localSQLquery = this.scfDBconnection.createStatement("SELECT "+String(this.scfDBfieldnames[localCounter2][0])+" AS name FROM data WHERE id = :cardid");
            localSQLquery.params.cardid = localSQLid;
            localSQLquery.executeStep();
            localFileConverter.writeString(String(localSQLquery.row.name));
            localSQLquery.reset();
            localSQLquery.finalize();
            if (localCounter2 == localFieldCounter) {
              localFileConverter.writeString("\n");
            } else {
              localFileConverter.writeString("\t");
            }
          }
        }
      } catch (e) {
        localSQLquery.reset();
        localSQLquery.finalize();
      }
      localFileConverter.close();
      localTempText = document.getElementById("scfStrings").getString("scfDataExportFinished");
      localPrompts.alert(null,localPromptTitle, localTempText);
    } else {
      localTempText = document.getElementById("scfStrings").getString("scfDataExportCancelMessage");
      localPrompts.alert(null,localPromptTitle, localTempText);
    }
  },

  scfDisplayHelp: function() {
    window.open("chrome://sqlcardfile/content/scfhOverlay.xul",
                "SQL Cardfile Help", "chrome,resizable");
  },

  scfDisplayAbout: function() {
    var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                           .getService(Components.interfaces.nsIPromptService);
    var localPromptTitle = document.getElementById("scfStrings").getString("scfDisplayAboutTitle");
    var localPromptMessage = document.getElementById("scfStrings").getString("scfDisplayAboutMessage");
    localPrompts.alert(null,localPromptTitle, localPromptMessage);
  },

  scfDataSort: function() {
    if (this.scfDBconnection != null) {
      var localDialogParams = {inn:null, out:null};
      localDialogParams.inn = this.scfDBfieldnames;
      var localRetVal = window.openDialog("chrome://sqlcardfile/content/scfsOverlay.xul", "",
                          "chrome, dialog, modal, resizable=yes", localDialogParams).focus();
      var localReturnArray = localDialogParams.out;
      if (Array.isArray(localReturnArray)) {
        this.scfCardSort = localReturnArray;
        document.getElementById("scfRunnerCardContainer").setAttribute("scfcardsort",
              localReturnArray[(localReturnArray.length-1)]);
	this.scfCardLoad(document.getElementById("scfRunnerCardContainer").getAttribute("scfcardoffset"));
      }
    }
  },

  scfDataUnSort: function() {
    if (this.scfDBconnection != null) {
      var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                             .getService(Components.interfaces.nsIPromptService);
      var localPromptTitle = document.getElementById("scfStrings").getString("scfDataUnSortTitle");
      var localPromptMessage = "";
      var localCardSort = String(document.getElementById("scfRunnerCardContainer").getAttribute("scfcardsort"));
      if (localCardSort != "blank") {
	localPromptMessage = document.getElementById("scfStrings").getString("scfDataUnSortMessage1");
	if (localPrompts.confirm(null,localPromptTitle, localPromptMessage)) {
	  document.getElementById("scfRunnerCardContainer").setAttribute("scfcardsort","blank");
	  this.scfCardLoad(document.getElementById("scfRunnerCardContainer").getAttribute("scfcardoffset"));
	}
      } else {
	localPromptMessage = document.getElementById("scfStrings").getString("scfDataUnSortMessage2");
	localPrompts.alert(null,localPromptTitle, localPromptMessage);
      }
    }
  },

  scfDataViewSort: function() {
    if (this.scfDBconnection != null) {
      var localPrompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                             .getService(Components.interfaces.nsIPromptService);
      var localPromptTitle = document.getElementById("scfStrings").getString("scfDataViewSortTitle");
      var localPromptMessage = "";
      var localCardSort = String(document.getElementById("scfRunnerCardContainer").getAttribute("scfcardsort"));
      if (localCardSort != "blank") {
        var localSortCount = this.scfCardSort.length - 1;
        var localCounter = 0;
	localPromptMessage = document.getElementById("scfStrings").getString("scfDataViewSortMessage1");
	for (localCounter = 0; localCounter < localSortCount; localCounter++) {
	  localPromptMessage = localPromptMessage + "\n\t" + this.scfCardSort[localCounter];
	}
	localPrompts.alert(null,localPromptTitle, localPromptMessage);
      } else {
	localPromptMessage = document.getElementById("scfStrings").getString("scfDataViewSortMessage2");
	localPrompts.alert(null,localPromptTitle, localPromptMessage);
      }
    }
  },

  scfExit: function() {
    this.scfDBclose();
    window.close();
  }
};

window.addEventListener("load", function () { scfRunner.onLoad(); }, false);
window.addEventListener("unload", function () { scfRunner.scfDBclose(); }, false);
window.addEventListener("close", function () { scfRunner.scfDBclose(); }, false);
